require('./lazy') ->
  @coerce entity: (input, next) ->
    next null, input.toUpperCase()
    
  @route stats:
    description: "Obtain a report on a particular combination of an entity and fixtures"
    template: '/stats/{league}/{entityType}/{entity}/{stats*}'
    GET: -> @ok stats: [12], entity: @link 'entity'

  @route entity:
    description: "A person or team"
    template: '/stats/{league}/{entityType}/{entity}'
    GET: -> @model.entity.find @entityNameOrKey

  @schema
    fixture:
      description: "A statistical fixture like offensive.tackles"
      type: 'string'
      
    league:
      description: "A league key such as l.mlb.com or l.ncaaf.org"
    entity:
      description: "A team"
      type: 'object'
      properties:
        entity_type:
          description: "Either 'team' or 'player"
          type: 'string'
        entity_key:
          description: 'A unique identifier for this team'
          type: 'string'
        full_name:
          description: 'The full name of the entity'
          type: 'string'
